package de.simsso.gswnpause;

import android.os.Bundle;
import android.app.Activity;
import android.graphics.Typeface;
import android.text.format.Time;
import android.util.TypedValue;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.LinearLayout.LayoutParams;

public class MainActivity extends Activity {

	private Time currentTime;
	private LinearLayout liste;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		
		aktualisieren();
	}

	
	
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		getMenuInflater().inflate(R.menu.menu, menu);
		return true;
	}


	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		switch (item.getItemId()) {
		case R.id.refresh:
			liste.removeAllViews();
			aktualisieren();
			return true;
		}
		return true;
	}



	private void aktualisieren () {
		//Zeit setzen
		currentTime = new Time();
		currentTime.setToNow();
		
		//Layoutreferenz finden
		liste = (LinearLayout) findViewById(R.id.liste);
		
		//Wochenende?
		if (currentTime.weekDay == Time.SATURDAY || currentTime.weekDay == Time.SUNDAY) {
			//Wochenende eintragen
			liste.addView(newItem("Es ist Wochenende!", R.color.green));
		}
		else {
			listemachen();
		}
	}
	
	private void listemachen() {
		addItem(7, 40, "1. Stunde", R.color.red);
		addItem(8, 25, "5 Minuten Pause", R.color.green);
		addItem(8, 30, "2. Stunde", R.color.red);
		addItem(9, 15, "20 Minuten Pause", R.color.green);
		addItem(9, 35, "3. Stunde", R.color.red);
		addItem(10, 20, "5 Minuten Pause", R.color.green);
		addItem(10, 25, "4. Stunde", R.color.red);
		addItem(11, 10, "15 Minuten Pause", R.color.green);
		addItem(11, 25, "5. Stunde", R.color.red);
		addItem(12, 10, "5 Minuten Pause", R.color.green);
		addItem(12, 15, "6. Stunde", R.color.red);
		addItem(13, 0, "5 Minuten Pause", R.color.green);
		addItem(13, 5, "7. Stunde", R.color.red);
		addItem(13, 50, "5 Minuten Pause", R.color.green);
		addItem(13, 55, "8. Stunde", R.color.red);
		addItem(14, 40, "15 Minuten Pause", R.color.green);
		addItem(14, 55, "9. Stunde", R.color.red);
		addItem(15, 40, "5 Minuten Pause", R.color.green);
		addItem(15, 45, "10. Stunde", R.color.red);
		addItem(16, 30, "5 Minuten Pause", R.color.green);
		addItem(16, 35, "11. Stunde", R.color.red);
		addItem(17, 20, "10 Minuten Pause", R.color.green);
		addItem(17, 30, "12. Stunde", R.color.red);
		addItem(18, 15, "13. Stunde", R.color.red);
		addItem(19, 0, "15 Minuten Pause", R.color.green);
		addItem(19, 15, "14. Stunde", R.color.red);
		addItem(20, 0, "15. Stunde", R.color.red, true);
	}

	private void addItem (int hstart, int minstart, String event, int color, boolean last) {
		if (currentTime.hour < hstart || (currentTime.hour == hstart && currentTime.minute < minstart)) {
			int min = minstart-currentTime.minute;
			short hminus = 0;
			if (min < 0) {
				min = min + 60;
				hminus = 1;
				
			}
			String mindisp = "";
			if (min != 0) {
				mindisp = String.valueOf(min) + "min";
			}
			int h = hstart-currentTime.hour - hminus;
			String hdisp = "";
			if (h > 0) {
				hdisp = String.valueOf(h) + "h ";
			}
			liste.addView(newItem(event + " (" + hdisp + mindisp + ")", color));
			if (!last) {
				liste.addView(trennlinie());
			}
		}
	}
	
	private void addItem (int hstart, int minstart, String event, int color) {
		addItem(hstart, minstart, event, color, false);
	}
	
	private TextView newItem (String text, int color) {
		TextView tv = new TextView(getApplicationContext());
		tv.setText(text);
		LinearLayout.LayoutParams weinfoParams = new LinearLayout.LayoutParams(
				LinearLayout.LayoutParams.WRAP_CONTENT, LinearLayout.LayoutParams.WRAP_CONTENT);
		tv.setLayoutParams(weinfoParams);
		tv.setTextColor(getResources().getColor(color));
		tv.setTextSize(18);
		//fett drucken
		if (color == R.color.green) {
			tv.setTypeface(Typeface.DEFAULT_BOLD);
		}
		return tv;
	}
	
	private View trennlinie () {
		View t = new View(getApplicationContext());
		t.setBackgroundColor(getResources().getColor(R.color.grey));
		LinearLayout.LayoutParams params = new LinearLayout.LayoutParams(LinearLayout.LayoutParams.MATCH_PARENT, 1);
		int m = (int) TypedValue.applyDimension(TypedValue.COMPLEX_UNIT_DIP, 8, getResources().getDisplayMetrics());
		params.setMargins(0, m, 0, m);
		t.setLayoutParams(params);
		return t;
	}
	
}
